unofficial mirror of notmuch@notmuchmail.org
 help / color / mirror / code / Atom feed
* [PATCH 1/3] test: add functions to count how much times notmuch was called
@ 2011-11-26  1:44 Dmitry Kurochkin
  2011-11-26  1:44 ` [PATCH 2/3] test: check that Emacs UI does not call notmuch for non-inlinable parts Dmitry Kurochkin
                   ` (5 more replies)
  0 siblings, 6 replies; 30+ messages in thread
From: Dmitry Kurochkin @ 2011-11-26  1:44 UTC (permalink / raw)
  To: notmuch

The patch adds two auxiliary functions and a variable:

  notmuch_counter_reset
  $notmuch_counter
  notmuch_counter

They allow to count how many times notmuch binary is called.
notmuch_counter_reset() function generates a script that counts how
many times it is called and resets the counter to zero.  The function
sets $notmuch_counter variable to the path to the generated script
that should be called instead of notmuch to do the counting.  The
notmuch_counter() function returns the current counter value.
---
 test/README      |   16 ++++++++++++++--
 test/test-lib.sh |   32 ++++++++++++++++++++++++++++++++
 2 files changed, 46 insertions(+), 2 deletions(-)

diff --git a/test/README b/test/README
index 2481f16..1570f7c 100644
--- a/test/README
+++ b/test/README
@@ -187,8 +187,8 @@ library for your script to use.
    is to summarize successes and failures in the test script and
    exit with an appropriate error code.
 
-There are also a number of mail-specific functions which are useful in
-writing tests:
+There are also a number of notmuch-specific auxiliary functions and
+variables which are useful in writing tests:
 
   generate_message
 
@@ -212,3 +212,15 @@ writing tests:
     will initialize the mail database to a known state of 50 sample
     messages, (culled from the early history of the notmuch mailing
     list).
+
+  notmuch_counter_reset
+  $notmuch_counter
+  notmuch_counter
+
+    These allow to count how many times notmuch binary is called.
+    notmuch_counter_reset() function generates a script that counts
+    how many times it is called and resets the counter to zero.  The
+    function sets $notmuch_counter variable to the path to the
+    generated script that should be called instead of notmuch to do
+    the counting.  The notmuch_counter() function returns the current
+    counter value.
diff --git a/test/test-lib.sh b/test/test-lib.sh
index 93867b0..e3b85d0 100755
--- a/test/test-lib.sh
+++ b/test/test-lib.sh
@@ -864,6 +864,38 @@ test_emacs () {
 	emacsclient --socket-name="$EMACS_SERVER" --eval "(progn $@)"
 }
 
+# Creates a script that counts how much time it is executed and calls
+# notmuch.  $notmuch_counter is set to the path to the generated
+# script.  Use notmuch_counter() function to get the current counter
+# value.
+notmuch_counter_reset () {
+	notmuch_counter="$TMP_DIRECTORY/notmuch_counter"
+	if [ ! -x "$notmuch_counter" ]; then
+		notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
+		cat <<EOF >"$notmuch_counter"
+#!/bin/sh
+
+count=\$(cat "$notmuch_counter_state_path")
+echo -n \$(expr \$count + 1) > "$notmuch_counter_state_path"
+
+exec notmuch "\$@"
+EOF
+		chmod +x "$notmuch_counter" || return
+	fi
+
+	echo -n 0 > "$notmuch_counter_state_path" || return
+}
+
+# Returns the current notmuch counter value.
+notmuch_counter () {
+	if [ -r "$notmuch_counter_state_path" ]; then
+		count=$(cat "$notmuch_counter_state_path")
+	else
+		count=0
+	fi
+	echo -n $count
+}
+
 
 find_notmuch_path ()
 {
-- 
1.7.7.3

^ permalink raw reply related	[flat|nested] 30+ messages in thread

end of thread, other threads:[~2011-12-08  1:00 UTC | newest]

Thread overview: 30+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2011-11-26  1:44 [PATCH 1/3] test: add functions to count how much times notmuch was called Dmitry Kurochkin
2011-11-26  1:44 ` [PATCH 2/3] test: check that Emacs UI does not call notmuch for non-inlinable parts Dmitry Kurochkin
2011-11-28  2:46   ` Austin Clements
2011-11-26  1:44 ` [PATCH 3/3] emacs: do not call notmuch show " Dmitry Kurochkin
2011-11-28  2:54   ` Austin Clements
2011-11-28  2:44 ` [PATCH 1/3] test: add functions to count how much times notmuch was called Austin Clements
2011-11-28  3:09   ` Dmitry Kurochkin
2011-11-28  3:28 ` [PATCH 0/3] emacs: do not call notmuch show for non-inlinable parts Dmitry Kurochkin
2011-11-28  3:28   ` [PATCH 1/3] test: add functions to count how much times notmuch was called Dmitry Kurochkin
2011-11-28 20:42     ` Tomi Ollila
2011-11-28 21:26       ` Dmitry Kurochkin
2011-11-29 12:58         ` Tomi Ollila
2011-11-29 21:03           ` Dmitry Kurochkin
2011-11-30 11:53             ` Tomi Ollila
2011-11-29 14:40         ` Jameson Graef Rollins
2011-11-28  3:28   ` [PATCH 2/3] test: check that Emacs UI does not call notmuch for non-inlinable parts Dmitry Kurochkin
2011-11-28  3:28   ` [PATCH 3/3] emacs: do not call notmuch show " Dmitry Kurochkin
2011-11-28  3:39   ` [PATCH 0/3] " Austin Clements
2011-11-28 14:24     ` Jameson Graef Rollins
2011-11-28 21:13 ` [PATCH v3 " Dmitry Kurochkin
2011-11-28 21:13   ` [PATCH v3 1/3] test: add functions to count how much times notmuch was called Dmitry Kurochkin
2011-11-28 21:13   ` [PATCH v3 2/3] test: check that Emacs UI does not call notmuch for non-inlinable parts Dmitry Kurochkin
2011-11-28 21:13   ` [PATCH v3 3/3] emacs: do not call notmuch show " Dmitry Kurochkin
2011-11-29 21:19 ` [PATCH v4 0/3] " Dmitry Kurochkin
2011-11-29 21:19   ` [PATCH v4 1/3] test: add functions to count how much times notmuch was called Dmitry Kurochkin
2011-11-30 11:57     ` Tomi Ollila
2011-11-29 21:19   ` [PATCH v4 2/3] test: check that Emacs UI does not call notmuch for non-inlinable parts Dmitry Kurochkin
2011-11-29 21:19   ` [PATCH v4 3/3] emacs: do not call notmuch show " Dmitry Kurochkin
2011-12-07 15:11   ` [PATCH v4 0/3] " Dmitry Kurochkin
2011-12-08  1:00   ` David Bremner

Code repositories for project(s) associated with this public inbox

	https://yhetil.org/notmuch.git/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).